    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------
    028     * XYIntervalSeries.java
    029     * ---------------------
    030     * (C) Copyright 2006, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: XYIntervalSeries.java,v 1.1.2.3 2007/02/13 14:23:52 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 20-Oct-2006 : Version 1 (DG);
    040     * 13-Feb-2007 : Added several new accessor methods (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.xy;
    045
    046    import org.jfree.data.ComparableObjectItem;
    047    import org.jfree.data.ComparableObjectSeries;
    048
    049    /**
    050     * A list of (x, x-low, x-high, y, y-low, y-high) data items.
    051     *
    052     * @since 1.0.3
    053     *
    054     * @see XYIntervalSeriesCollection
    055     */
    056    public class XYIntervalSeries extends ComparableObjectSeries {
    057
    058        /**
    059         * Creates a new empty series.  By default, items added to the series will
    060         * be sorted into ascending order by x-value, and duplicate x-values will
    061         * be allowed (these defaults can be modified with another constructor).
    062         *
    063         * @param key  the series key (<code>null</code> not permitted).
    064         */
    065        public XYIntervalSeries(Comparable key) {
    066            this(key, true, true);
    067        }
    068
    069        /**
    070         * Constructs a new xy-series that contains no data.  You can specify
    071         * whether or not duplicate x-values are allowed for the series.
    072         *
    073         * @param key  the series key (<code>null</code> not permitted).
    074         * @param autoSort  a flag that controls whether or not the items in the
    075         *                  series are sorted.
    076         * @param allowDuplicateXValues  a flag that controls whether duplicate
    077         *                               x-values are allowed.
    078         */
    079        public XYIntervalSeries(Comparable key, boolean autoSort,
    080                boolean allowDuplicateXValues) {
    081            super(key, autoSort, allowDuplicateXValues);
    082        }
    083
    084        /**
    085         * Adds a data item to the series.
    086         *
    087         * @param x  the x-value.
    088         * @param xLow  the lower bound of the x-interval.
    089         * @param xHigh  the upper bound of the x-interval.
    090         * @param y  the y-value.
    091         * @param yLow  the lower bound of the y-interval.
    092         * @param yHigh  the upper bound of the y-interval.
    093         */
    094        public void add(double x, double xLow, double xHigh, double y, double yLow,
    095                double yHigh) {
    096            super.add(new XYIntervalDataItem(x, xLow, xHigh, y, yLow, yHigh), true);
    097        }
    098
    099        /**
    100         * Returns the x-value for the specified item.
    101         *
    102         * @param index  the item index.
    103         *
    104         * @return The x-value (never <code>null</code>).
    105         */
    106        public Number getX(int index) {
    107            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    108            return item.getX();
    109        }
    110
    111        /**
    112         * Returns the lower bound of the x-interval for the specified item in the
    113         * series.
    114         *
    115         * @param index  the item index.
    116         *
    117         * @return The lower bound of the x-interval.
    118         *
    119         * @since 1.0.5
    120         */
    121        public double getXLowValue(int index) {
    122            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    123            return item.getXLowValue();
    124        }
    125
    126        /**
    127         * Returns the upper bound of the x-interval for the specified item in the
    128         * series.
    129         *
    130         * @param index  the item index.
    131         *
    132         * @return The upper bound of the x-interval.
    133         *
    134         * @since 1.0.5
    135         */
    136        public double getXHighValue(int index) {
    137            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    138            return item.getXHighValue();
    139        }
    140
    141        /**
    142         * Returns the y-value for the specified item.
    143         *
    144         * @param index  the item index.
    145         *
    146         * @return The y-value.
    147         */
    148        public double getYValue(int index) {
    149            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    150            return item.getYValue();
    151        }
    152
    153        /**
    154         * Returns the lower bound of the Y-interval for the specified item in the
    155         * series.
    156         *
    157         * @param index  the item index.
    158         *
    159         * @return The lower bound of the Y-interval.
    160         *
    161         * @since 1.0.5
    162         */
    163        public double getYLowValue(int index) {
    164            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    165            return item.getYLowValue();
    166        }
    167
    168        /**
    169         * Returns the upper bound of the y-interval for the specified item in the
    170         * series.
    171         *
    172         * @param index  the item index.
    173         *
    174         * @return The upper bound of the y-interval.
    175         *
    176         * @since 1.0.5
    177         */
    178        public double getYHighValue(int index) {
    179            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    180            return item.getYHighValue();
    181        }
    182
    183        /**
    184         * Returns the data item at the specified index.
    185         *
    186         * @param index  the item index.
    187         *
    188         * @return The data item.
    189         */
    190        public ComparableObjectItem getDataItem(int index) {
    191            return super.getDataItem(index);
    192        }
    193
    194    }